"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = createFarceRouter;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _Actions = _interopRequireDefault(require("farce/Actions"));

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _createConnectedRouter = _interopRequireDefault(require("./createConnectedRouter"));

var _createFarceStore = _interopRequireDefault(require("./createFarceStore"));

function createFarceRouter(_ref) {
  let {
    store,
    historyProtocol,
    historyMiddlewares,
    historyOptions,
    routeConfig
  } = _ref,
      options = (0, _objectWithoutPropertiesLoose2.default)(_ref, ["store", "historyProtocol", "historyMiddlewares", "historyOptions", "routeConfig"]);
  const ConnectedRouter = (0, _createConnectedRouter.default)(options);

  class FarceRouter extends _react.default.Component {
    constructor(props) {
      super(props);
      this.store = store || (0, _createFarceStore.default)({
        historyProtocol,
        historyMiddlewares,
        historyOptions,
        routeConfig
      });
    }

    componentWillUnmount() {
      this.store.dispatch(_Actions.default.dispose());
    }

    render() {
      return /*#__PURE__*/_react.default.createElement(_reactRedux.Provider, {
        store: this.store
      }, /*#__PURE__*/_react.default.createElement(ConnectedRouter, this.props));
    }

  }

  return FarceRouter;
}

module.exports = exports.default;